//---------------------------------------------------------------------------


#pragma hdrstop

#include "Crc32.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)



// define static member

FastCrc::Table FastCrc::_table;

void FastCrc::Table::Init (Crc::Type key)
{
	assert (key != 0);
	if (key == _key)
		return;
	_key = key;

	// for all possible byte values
	for (unsigned i = 0; i < 256; ++i)
	{
		Crc::Type reg = i << 24;
		// for all bits in a byte
		for (int j = 0; j < 8; ++j)
		{
			bool topBit = (reg & 0x80000000) != 0;
			reg <<= 1;
			if (topBit)
				reg ^= _key;
		}
		_table [i] = reg;
	}
}

void FastCrc::PutByte (unsigned byte)
{
	unsigned top = _register >> 24;
	top ^= byte;
	_register = (_register << 8) ^ _table [top];
}
/*
int main ()
{
	std::string msg ("Harry had a little lamp");
	std::string exMsg (msg);
	exMsg.resize (msg.length () + 4);

	Crc::Type const ethernetKey = 0x04c11db7;

	FastCrc fastCrc (ethernetKey);

	for (int i = 0; i < msg.length (); ++i)
	{
		fastCrc.PutByte (msg [i]);
	}
	Crc::Type newCrc = fastCrc.Done ();
	std::cout << "\n0x" << std::hex << newCrc << std::endl;

	return 0;
}
 */
