//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "uCiaComport"
#pragma link "WSocket"
#pragma link "JvAppIniStorage"
#pragma link "JvAppStorage"
#pragma link "JvComponentBase"
#pragma link "JvFormPlacement"
#pragma link "JvCombobox"
#pragma link "JvEdit"
#pragma link "JvExControls"
#pragma link "JvExStdCtrls"
#pragma link "JvgLabel"
#pragma link "JvLabel"
#pragma link "JvLED"
#pragma link "JvValidateEdit"
#pragma link "JvXPButtons"
#pragma link "JvXPCore"
#pragma link "JvXPCheckCtrls"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        FClients     = new TList;
        UnRealHeaderGotIt=false;
        CiaComPort1->GetAvailablePorts(JvComboBoxRS232Port->Items);
        mod=0;demod=0;
        criticalsection=new TCriticalSection;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SocketUnRealTCPServerListnerSessionAvailable(
      TObject *Sender, WORD ErrCode)
{
        TWSocket *NewClient;
        NewClient = new TWSocket(NULL);
        FClients->Add(NewClient);
        NewClient->MultiCast=false;
        NewClient->KeepAliveOnOff=wsKeepAliveOnSystem;
        NewClient->LingerOnOff=wsLingerOff;
        NewClient->OnDataAvailable     = ClientDataAvailable;
        NewClient->OnSessionClosed     = ClientSessionClosed;
        NewClient->HSocket             = SocketUnRealTCPServerListner->Accept();
        if(QAMUnRealHeaderGotIt)NewClient->Send(QAMUnRealHeader,QAMUnRealHeadersize);
         else
         {
                NewClient->CloseDelayed();
         }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SocketUnRealTCPClientSessionConnected(
      TObject *Sender, WORD ErrCode)
{
        UnRealHeaderGotIt=false;
        UnRealClientLED->Status=false;
        UnRealClientLED->Active=true;
        SocketUnRealTCPClient->SendStr("live-alias:"+JvEditUnRealAlias->Text);        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SocketUnRealTCPClientSessionClosed(TObject *Sender,
      WORD ErrCode)
{
        UnRealHeaderGotIt=false;
        UnRealClientLED->Active=false;
        UnRealClientLED->Status=false;
        if(ModLED->Status)UnRealClientLED->ColorOff=clRed;
        if(ErrCode==10057)
        {
                ShowMessage("UnReal Media server is needed and can't be found.\nIf it's installed, check your settings are correct.\nElse download it from http://www.umediaserver.net\n");
        } else if(ModLED->Status)ShowMessage("UnReal media server connection has closed.\nThis is probably because the Alais link was not found on the server.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SocketUnRealTCPClientDataAvailable(TObject *Sender,
      WORD ErrCode)
{
        int Len;
        int i;
        unsigned char Buf[4098];
        unsigned long crc32;
        FastCrc fastCrc (0x04c11db7);
        if(!UnRealHeaderGotIt)
        {

                UnRealHeadersize=SocketUnRealTCPClient->Receive(UnRealHeader,sizeof(UnRealHeader)-4);
                UnRealClientLED->Active=false;
                UnRealClientLED->Status=true;
                UnRealHeaderGotIt=true;

                for(i=0;i<UnRealHeadersize;i++)fastCrc.PutByte(UnRealHeader[i]);
                crc32=fastCrc.Done();

                UnRealHeader[UnRealHeadersize]=(unsigned char)(crc32&255);
                UnRealHeader[UnRealHeadersize+1]=(unsigned char)((crc32>>8)&255);
                UnRealHeader[UnRealHeadersize+2]=(unsigned char)((crc32>>16)&255);
                UnRealHeader[UnRealHeadersize+3]=(unsigned char)((crc32>>24)&255);
                UnRealHeadersize+=4;

        }
         else
         {
                Len=SocketUnRealTCPClient->Receive(Buf,sizeof(Buf));
                if(mod&&(Len>=0))LoadNextBufferPacket(Buf,Len,ptUnReal);
         }
        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UnRealHeaderTimerTimer(TObject *Sender)
{
        if(UnRealHeaderGotIt&&mod)LoadNextBufferPacket(UnRealHeader,UnRealHeadersize,ptUnRealHeader);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    if (FClients) {
        delete FClients;
        FClients = NULL;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        JvXPButtonStopClick(this);
        if(criticalsection)delete criticalsection;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::JvXPButtonStartClick(TObject *Sender)
{
        JvXPButtonStopClick(this);
        CiaComPort1->Baudrate=JvComboBoxRS232Baudrate->Text.ToInt();
        CiaComPort1->Port=JvComboBoxRS232Port->Text.ToInt();
        if(!CiaComPort1->PortOpen()){ShowMessage("cant open com port");return;}
        CiaComPort1->PurgeTx();
        mod=JvXPCheckboxModOn->Checked;
        demod=JvXPCheckboxDeModOn->Checked;
        if(mod)
        {
                UnRealHeaderTimer->Interval=1000*JvValidateEditUnRealHeaderSendPriod->Value;
                UnRealHeaderTimer->Enabled=true;
                SocketUnRealTCPClient->Addr=JvEditUnRealServerAddr->Text;
                SocketUnRealTCPClient->Port=(AnsiString)JvValidateEditUnRealServerPort->Value;
                SocketUnRealTCPClient->Proto="tcp";
                SocketUnRealTCPClient->Connect();
        }
        if(demod)
        {
                SocketUnRealTCPServerListner->Addr="0.0.0.0";
                SocketUnRealTCPServerListner->Port=(AnsiString)JvValidateEditUnRealQAMTcpPort->Value;
                SocketUnRealTCPServerListner->Proto="tcp";
                SocketUnRealTCPServerListner->Listen();
        }
        if(mod)ModLED->Status=true;
         else ModLED->Status=false;
        if(demod)DeModLED->Status=true;
         else DeModLED->Status=false;
         CiaComPort1->ClearTxBuf();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientDataAvailable(TObject *Sender,
      WORD Error)
{
    char Buf[1280];
    int  Len;
    Len = ((TWSocket *)Sender)->Receive(&Buf, sizeof(Buf) - 1);

    if (Len <= 0)return;
    // Remove any trailing CR/LF
    while ((Len > 0) &&
           ((Buf[Len - 1] == '\r') || (Buf[Len - 1] == '\n')))
        Len--;
    // Nul terminate data
    Buf[Len] = 0;

  //  Display("DataAvailable: \"" + (AnsiString)Buf + "\"\r");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClientSessionClosed(TObject *Sender,
      WORD Error)
{
    TWSocket *Cli;
    int      Itm;

    Cli = (TWSocket *)Sender;
 //   Display("Client diconnected\r");

    Itm = FClients->IndexOf(Cli);
    if (Itm >= 0)
        FClients->Delete(Itm);
    // We can"t destroy a TWSocket from a SessionClosed event handler.
    // So we post a message to delay destruction until we are out of the
    // message handler.
    PostMessage(Handle, WM_DESTROY_SOCKET, 0, (LPARAM)Cli);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WMDestroySocket(TMessage Msg)
{
    delete (TWSocket *)(Msg.LParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadNextBufferPacket(unsigned char * Buf,int Len,PacketType type_of_packet)
{
        if(!mod)return;
        if(Len>20000)return ;///arrrg to big shound say
        int checksum=0;
        unsigned char b[4];
        for(register i=0;i<Len;i++)checksum+=Buf[i];
        b[0]=0;//start/stop packet symbol
        b[1]=(((checksum&31)<<3)|type_of_packet); //send type of packet with checksum
        b[2]=Len/256; //send size of packet
        b[3]=Len%256; //send size of packet
        SendRs232(b,4);
        SendRs232(Buf,Len);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::JvXPButtonStopClick(TObject *Sender)
{
        mod=0;demod=0;
        UnRealHeaderTimer->Enabled=false;
        UnRealServerLED->Status=false;
        UnRealClientLED->Active=false;
        UnRealClientLED->Status=false;
        ModLED->Status=false;
        DeModLED->Status=false;
        QAMUnRealHeaderGotIt=false;
        UnRealServerLED->Status=false;
        UnRealHeaderLED->Status=false;
        UnRealClientLED->Active=false;
        UnRealClientLED->Status=false;
        SocketUnRealTCPServerListner->Close();
        SocketUnRealTCPServerListner->WaitForClose();
        SocketUnRealTCPClient->Close();
        SocketUnRealTCPClient->WaitForClose();
        UnRealHeaderLED->Status=false;
        for (int I = 0; I < FClients->Count; I++)
        {
                try
                {
                        ((TWSocket *)(FClients->Items[I]))->Close();
                        ((TWSocket *)(FClients->Items[I]))->WaitForClose();
                }
                catch (...)
                {
                        //like i now how to do exceptions
                }
        }

        rs232outcharbufptr=0;
        sending=false;
        if(CiaComPort1->Open)
        {
                CiaComPort1->PurgeTx();
                CiaComPort1->PortClose();
                CiaComPort1->PurgeTx();
        }

        QAMUnRealHeaderGotIt=false;
        UnRealHeaderLED->Status=false;
        OverFlowLED->Status=false;
        UnRealClientLED->ColorOff=clBtnShadow;
        sending=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CiaComPort1DataAvailable(TObject *Sender)
{
        unsigned count=CiaComPort1->Receive(rs232incharbuf,sizeof(rs232incharbuf));
        if(!demod)return;
        unsigned char x;
        for(unsigned int i=0;i<count;i++)
        {
                x=rs232incharbuf[i];
                if((!fullingpacket)&&(x==0))
                {
                        fullingpacket=true;
                        packetinbufptr=0;
                        packetsize=sizeof(packetinbuf);
                        continue;
                }
                if(fullingpacket)
                {
                        packetinbuf[packetinbufptr]=x;
                        packetinbufptr++;packetinbufptr%=sizeof(packetinbuf);
                        if(packetinbufptr==3)
                        {
                                packetsize=((int)packetinbuf[1])*256+((int)packetinbuf[2])+3;
                                if(sizeof(packetinbuf)<=(packetsize))
                                {
                                        fullingpacket=false;
                                        packetinbufptr=0;
                                }
                        }
                        if(packetinbufptr>=packetsize)
                        {
                                //got packet
                                fullingpacket=false;
                                int checksum=0;
                                for(register int j=3;j<packetinbufptr;j++)checksum+=packetinbuf[j];
                                if((checksum&31)==(((packetinbuf[0])>>3)&31)) //see if its a good packet
                                {
                                        //got good packet
                                        switch((packetinbuf[0])&7)
                                        {
                                                case ptUnReal:
                                                        for(int k = 0; k < FClients->Count; k++)
                                                        {
                                                                try
                                                                {
                                                                        if(((TWSocket *)(FClients->Items[k]))->State==wsConnected)((TWSocket *)(FClients->Items[k]))->Send(&packetinbuf[3],packetsize-3);
                                                                }
                                                                catch (...)
                                                                {
                                                                        //like i now how to do exceptions
                                                                }
                                                        }
                                                break;
                                                case ptUnRealHeader:
                                                        if((packetsize>8)&&(packetsize<1000))
                                                        {
                                                                unsigned long crc32,crc32rec;
                                                                FastCrc fastCrc (0x04c11db7);
                                                                for(int k=3;k<(packetsize-4);k++)fastCrc.PutByte(packetinbuf[k]);
                                                                crc32=fastCrc.Done();
                                                                unsigned long *tp;
                                                                tp=(unsigned long *)&packetinbuf[packetsize-4];
                                                                crc32rec=*tp;
                                                                if(crc32rec==crc32)
                                                                {
                                                                        UnRealHeaderLED->Status=true;
                                                                        QAMUnRealHeadersize=packetsize-7;
                                                                        for(int k=0;k<QAMUnRealHeadersize;k++)QAMUnRealHeader[k]=packetinbuf[k+3];
                                                                        QAMUnRealHeaderGotIt=true;
                                                                }
                                                        }
                                                break;
                                        };
                                }
                        }
                }
        }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CiaComPort1DataSent(TObject *Sender)
{
        criticalsection->Acquire();
        CiaComPort1->PurgeTx();
        if(rs232outcharbufptr)
        {
                CiaComPort1->Send(rs232outcharbuf,rs232outcharbufptr);
                rs232outcharbufptr=0;
        }
        else
        {
                sending=false;
        }
        criticalsection->Release();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SendRs232(unsigned char * Buf,int Len)
{
        criticalsection->Acquire();
        if(sending)
        {
                for(int i=0;i<Len;i++)
                {
                        rs232outcharbuf[rs232outcharbufptr]=Buf[i];
                        rs232outcharbufptr++;
                        if(rs232outcharbufptr>=sizeof(rs232outcharbuf))
                        {
                                rs232outcharbufptr=0;
                                OverFlowLED->Status=true;
                                overflowevent=true;
                        }
                }
        }
        else
        {
                rs232outcharbufptr=0;
                sending=true;
                CiaComPort1->Send(Buf,Len);
        }
        criticalsection->Release();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        if(FClients->Count>0)UnRealServerLED->Status=true;
         else UnRealServerLED->Status=false;
        if(overflowevent)overflowevent=false;
         else OverFlowLED->Status=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::JvXPCheckboxModOnClick(TObject *Sender)
{
        JvXPCheckboxDeModOn->Checked=false;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::JvXPCheckboxDeModOnClick(TObject *Sender)
{
        JvXPCheckboxModOn->Checked=false;        
}
//---------------------------------------------------------------------------

